#!/usr/bin/perl
## ----------------------------------------------------------------------------
##
## sdb-suche
## =========
##
## CGI-Skript zur interaktiven Stichwortsuche in der Supportdatenbank
##
## (c) 1997 S.u.S.E. GmbH - Bodo Bauer <bb@suse.de> & Klaus Franken <kfr@suse.de>
## (c) 1998 S.u.S.E. GmbH - Rdiger Oertel <ro@suse.de>
## (c) 1999 SuSE GmbH - Martin Scherbaum <maddin@suse.de>
## ----------------------------------------------------------------------------

if ($0 =~ /sdbsearch_en.cgi$/) {
	$sect = en;
	$lang = en;
} elsif ($0 =~ /sdbsearch_fr.cgi$/) {
        $sect = fr;
        $lang = fr;
} elsif ($0 =~ /sdbsearch_it.cgi$/) {
        $sect = it;
        $lang = it;
} elsif ($0 =~ /sdbsearch_es.cgi$/) {
        $sect = es;
        $lang = es;
} elsif ($0 =~ /sdbsearch_faq.cgi$/) {
        $sect = faq;
        $lang = de;
} elsif ($0 =~ /sdbsearch_prd.cgi$/) {
        $sect = prd;
        $lang = en;
} elsif ($0 =~ /sdbsearch_prj.cgi$/) {
        $sect = prj;
        $lang = en;
} elsif ($0 =~ /sdbsearch_pt.cgi$/) {
        $sect = pt;
        $lang = en;
} else {
        $sect = de;
	$lang = de;
}

require "./sdbtxt/$lang";
require "./sdbtxt/$sect";

##
## Felder aus QUERY_STRING extrahieren (ungetestet fuer Text-Fields!)
##
sub getfields {
    @f = split ( /&/, $ENV{"QUERY_STRING"} );
    for ( $i=0; $i<=$#f; $i++ ) {
	( $n, $v ) = split ( /=/, $f[$i], 2 );
	$field{$n} = $v;
    }
}

##
## Main
##
&getfields();

## woher kommen wir denn?
$KEYLISTNAME="keylist.txt";
$HTTP_REFERER=$ENV{'HTTP_REFERER'};
$SOURCEPATH= $HTTP_REFERER;
$SOURCEPATH =~ s?^http://[\w\.\-]*??;
$SOURCEPATH =~ s?\w*\.html$??;
$SOURCEPATH =~ s?/$??;
$ROOT = $ENV{'DOCUMENT_ROOT'};
if ($SOURCEPATH eq '') {
    $SOURCEPATH = "/sdb/$sect";
}
$keylist = "$ROOT/$SOURCEPATH/$KEYLISTNAME";

$PRIVAT = $HTTP_REFERER =~ /^http:\/\/w3/i;

if (! -r $keylist && -r "$ROOT/$SOURCEPATH/../$sect/html/$KEYLISTNAME") {
	$SOURCEPATH="$SOURCEPATH/../$sect/html";
	$keylist = "$ROOT/$SOURCEPATH/$KEYLISTNAME";
}

if (! -r $keylist && -r "$ROOT/sdb/$sect/html/$KEYLISTNAME") {
	$SOURCEPATH="/sdb/$sect/html";
	$keylist = "$ROOT/$SOURCEPATH/$KEYLISTNAME";
}

# fix by tmg 1999/11/08
if (! -r $keylist && -r "/usr/doc/sdb/$sect/html/$KEYLISTNAME") {
        $ROOT='/usr/doc';
        $SOURCEPATH="/sdb/$sect/html";
        $keylist = "/usr/doc/$SOURCEPATH/$KEYLISTNAME";
}



# set the links line
$sdbWriteLinks = "<p><img alt=\"---\" src=\"$SOURCEPATH/../../gifs/gl.gif\" height=2 width=100\%><p>
<strong>
<a href=$SOURCEPATH/index.html>$SDB_TXT{'hauptseite'}</a>
<IMG ALT=\"----\" ALIGN=TOP SRC=\"$SOURCEPATH/../../gifs/green2.gif\">
<a href=$SOURCEPATH/key_form.html>$SDB_TXT{'suchmaske'}</a>
<IMG ALT=\"----\" ALIGN=TOP SRC=\"$SOURCEPATH/../../gifs/green2.gif\">
<a href=$SOURCEPATH/history.html>$SDB_TXT{'history'}</a>
<IMG ALT=\"----\" ALIGN=TOP SRC=\"$SOURCEPATH/../../gifs/green2.gif\">
<a href=$SOURCEPATH/versionspage.html>$SDB_TXT{'versions'}</a>
<IMG ALT=\"----\" ALIGN=TOP SRC=\"$SOURCEPATH/../../gifs/green2.gif\">
<a href=$SOURCEPATH/katlist.html>$SDB_TXT{'category'}</a>
<IMG ALT=\"----\" ALIGN=TOP SRC=\"$SOURCEPATH/../../gifs/green2.gif\">
<a href=$SOURCEPATH/inhalt.html>$SDB_TXT{'inhalt'}</a>
</strong>
<img alt=\"---\" src=\"$SOURCEPATH/../../gifs/gl.gif\" height=2 width=100\%>\n";

## Zu suchendes Stichwort wird in Maskenfeld 'stichwort' eingelesen
$search = "\U$field{\"stichwort\"}\E";

$search =~ s/%2./+/g;
$search =~ s/\+\+/+/g;
@SEARCH = split(/\+/, $search);

## Ausgabe des HTML-Kopfes und des Anfangs der Antwort
$bgcolor = ($PRIVAT) ? "#dcdcdc" : "#ffffff";

print "Content-type: text/html\n
<html>\n<head>
<title>SDB: $SDB_TXT{'suchergebnis'} $search</title>
</head>\n
<body bgcolor=$bgcolor>
<a href=\"http://www.suse.de\"><IMG hspace=10 ALIGN=left SRC=\"$SOURCEPATH/../../gifs/suse_150.gif\"></a>
<H1>$SDB_TXT{'sdbtitle'}</H1>
<H2>$SDB_TXT{'titel'}: $SDB_TXT{'suchergebnis'} <strong><i>$search</i></strong></H2>\n";

print $sdbWriteLinks;

## Indexdatei durchsuchen, die gefundenen Eintraege formatieren und ausgeben
local (%FOUND);
local ($found) = 0;
local ($validitems) = 0;

foreach $searchitem (@SEARCH) {
    next if (!$searchitem);
    next if ($searchitem =~ /^\s*$/);

    $validitems++;
    local( $trite ) = $searchitem;
    $trite =~ s/[-\/\.\_\', ]//g;

    open ( KEYS, "$keylist" ) 
	|| print "$0: can't open '$keylist': $!";
    while ( <KEYS> ) {
	( $key, $file ) = split ( /\0/, $_, 2 );
	
	$file =~ s/.html$/.txt/;
	
	$key =~ s/[-\/\.\_\', ]//g;
	if ( $key =~ /$trite/ ) {
	    
	    open ( KEYSKEYS, "$ROOT/$SOURCEPATH/$file" )
		|| print "$0: can't open '$ROOT/$SOURCEPATH/$file': $!";
	    
	    while ( <KEYSKEYS> ) {
		
		( $key, $url, $headline ) = split ( /\0/, $_, 3 );
		
		$FOUND{"$headline\0$url"} || $found++;
		$FOUND{"$headline\0$url"} = 1;
	    }
	    
	    close ( KEYSKEYS );
	}
	
    }
    close ( KEYS );
}

if($validitems == 0) {
    print "<h3>$SDB_TXT{'gefunden4'}</h3>\n";
} elsif ($found == 0) {
    print "<H3>$SDB_TXT{'gefunden2'} </H3><H2><i>$search</i></H2><H3>$SDB_TXT{'gefunden3'}</H3>\n";
} else {
    print "<H3>$found $SDB_TXT{'gefunden1'} <strong><I>$search</I></strong>$SDB_TXT{'gefunden3'}:</H3><P>\n<ul>\n";
    foreach $key (sort keys(%FOUND)) 
    {
	($headline, $url) = split( /\0/, $key, 2 );
	print "<LI> <A HREF=\"$SOURCEPATH/$url\"> $headline</A>\n";
    }
    print "</ul>\n";
}

## HTML-Datei sauber schliessen.
if ($PRIVAT) {
    ## Hinweis auf interne Datenbank geben!
    print "<IMG ALT=\"---- \" ALIGN=TOP SRC=\"$SOURCEPATH/../../gifs/gl.gif\">\n";
    print "<P> <BLINK>$SDB_TXT{'suchpriv'}</BLINK><P>\n";
}

print $sdbWriteLinks;
print "<ADDRESS>
SDB-$SDB_TXT{'suchergebnis'}, Copyright <a href=\"http://www.suse.de/\">SuSE GmbH</a>, Nuremberg, Germany <br>
<A HREF=\"http://www.suse.de/impressum.html\">Impressum</A>
- Last changed: Son Feb 28 22:47:09 MET 1999  by maddin with emacs 
</ADDRESS>
</body>\n
</html>\n";

# statistics:
$keywordlog = "/var/log/sdb_keywords_$sect";
if (! $PRIVAT && $search && -w $keywordlog && open(FH, ">>$keywordlog")) {
        open(FH, ">>$keywordlog");
        print FH "$search,$found\n";
        close (FH);
}

# Thats all
